import { ChatKittyUploadProgressListener, CreateChatKittyFileProperties } from './file';
import { ChatKittyFailedResult, ChatKittySucceededResult } from './result';
import { BaseUser } from './user';
export type CurrentUser = BaseUser & {
    /** @internal */
    _relays: CurrentUserRelays;
    /** @internal */
    _topics: CurrentUserTopics;
    /** @internal */
    _actions: CurrentUserActions;
    /** @internal */
    _streams: CurrentUserStreams;
};
declare class CurrentUserRelays {
    self: string;
    readFileAccessGrant: string;
    writeFileAccessGrant: string;
    channelsCount: string;
    channels: string;
    messages: string;
    joinableChannels: string;
    unreadChannelsCount: string;
    unreadChannels: string;
    unreadMessagesCount: string;
    contactsCount: string;
    contacts: string;
    userBlockedRecords: string;
}
declare class CurrentUserTopics {
    self: string;
    channels: string;
    messages: string;
    notifications: string;
    contacts: string;
    participants: string;
    users: string;
    reactions: string;
    threads: string;
    calls: string;
}
declare class CurrentUserActions {
    update: string;
    createChannel: string;
    updateDisplayPicture: string;
}
declare class CurrentUserStreams {
    displayPicture: string;
}
export type RetrieveCurrentUserResult = RetrieveCurrentUserSuccessfulResult | ChatKittyFailedResult;
export declare class RetrieveCurrentUserSuccessfulResult extends ChatKittySucceededResult {
    user: CurrentUser;
    constructor(user: CurrentUser);
}
export type UpdateCurrentUserResult = UpdatedCurrentUserResult | ChatKittyFailedResult;
export declare class UpdatedCurrentUserResult extends ChatKittySucceededResult {
    user: CurrentUser;
    constructor(user: CurrentUser);
}
export declare class UpdateCurrentUserDisplayPictureRequest {
    file: CreateChatKittyFileProperties;
    progressListener?: ChatKittyUploadProgressListener;
}
export type UpdateCurrentUserDisplayPictureResult = UpdatedCurrentUserDisplayPictureResult | ChatKittyFailedResult;
export declare class UpdatedCurrentUserDisplayPictureResult extends ChatKittySucceededResult {
    user: CurrentUser;
    constructor(user: CurrentUser);
}
export {};
//# sourceMappingURL=current-user.d.ts.map