function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
// Bundled with Packemon: https://packemon.dev
// Platform: browser, Support: stable, Format: esm

import * as encoding from 'text-encoding-polyfill';
import { BehaviorSubject, Subject } from 'rxjs';
import { take, debounceTime } from 'rxjs/operators';
import { RxStomp, Versions, RxStompState } from '@stomp/rx-stomp';
import Axios from 'axios';
import { encode } from 'base-64';
import { v4 } from 'uuid';
import sockjs from 'sockjs-client/dist/sockjs';
const scope = typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : {};
if (typeof scope.crypto !== 'object') {
  scope.crypto = {
    getRandomValues: array => array.map(() => Math.floor(Math.random() * 256))
  };
}
if (typeof scope.TextEncoder !== 'object' || typeof scope.TextDecoder !== 'object') {
  scope.TextEncoder = encoding.TextEncoder;
  scope.TextDecoder = encoding.TextDecoder;
}
class ChatKittyError {
  constructor(error, message) {
    this.error = error;
    this.message = message;
  }
}
class ChatKittySucceededResult {
  succeeded = true;
  failed = false;
}
class ChatKittyFailedResult {
  succeeded = false;
  failed = true;
  constructor(error) {
    this.error = error;
  }
}
class CountSucceededResult extends ChatKittySucceededResult {
  constructor(count) {
    super();
    this.count = count;
  }
}
function isDirectChannel(channel) {
  return channel.type === 'DIRECT';
}
function isPublicChannel(channel) {
  return channel.type === 'PUBLIC';
}
function isPrivateChannel(channel) {
  return channel.type === 'PRIVATE';
}
class CreatedChannelResult extends ChatKittySucceededResult {
  constructor(channel) {
    super();
    this.channel = channel;
  }
}
class ListChannelsSucceededResult extends ChatKittySucceededResult {
  constructor(paginator) {
    super();
    this.paginator = paginator;
  }
}
class RetrieveChannelSucceededResult extends ChatKittySucceededResult {
  constructor(channel) {
    super();
    this.channel = channel;
  }
}
class RetrieveChannelContextSucceededResult extends ChatKittySucceededResult {
  constructor(context) {
    super();
    this.context = context;
  }
}
class CheckChannelUnreadSucceededResult extends ChatKittySucceededResult {
  constructor(unread) {
    super();
    this.unread = unread;
  }
}
class JoinedChannelResult extends ChatKittySucceededResult {
  constructor(channel) {
    super();
    this.channel = channel;
  }
}
class ChannelNotPubliclyJoinableError extends ChatKittyError {
  constructor(channel) {
    super('ChannelNotPubliclyJoinableError', `The channel ${channel.name} can't be joined without an invite.`);
    this.channel = channel;
  }
}
class AddedChannelModeratorResult extends ChatKittySucceededResult {
  constructor(channel) {
    super();
    this.channel = channel;
  }
}
class CannotAddModeratorToChannelError extends ChatKittyError {
  constructor(channel) {
    super('CannotAddModeratorToChannel', `The channel ${channel.name} is not a group channel and cannot have moderators.`);
    this.channel = channel;
  }
}
class MutedChannelResult extends ChatKittySucceededResult {
  constructor(channel) {
    super();
    this.channel = channel;
  }
}
class UnmutedChannelResult extends ChatKittySucceededResult {
  constructor(channel) {
    super();
    this.channel = channel;
  }
}
class LeftChannelResult extends ChatKittySucceededResult {
  constructor(channel) {
    super();
    this.channel = channel;
  }
}
class NotAChannelMemberError extends ChatKittyError {
  constructor(channel) {
    super('NotAChannelMemberError', `You are not a member of channel ${channel.name}.`);
    this.channel = channel;
  }
}
class ReadChannelSucceededResult extends ChatKittySucceededResult {
  constructor(channel) {
    super();
    this.channel = channel;
  }
}
class ClearChannelHistorySucceededResult extends ChatKittySucceededResult {
  constructor(channel) {
    super();
    this.channel = channel;
  }
}
class HideChannelSucceededResult extends ChatKittySucceededResult {
  constructor(channel) {
    super();
    this.channel = channel;
  }
}
class InvitedUserResult extends ChatKittySucceededResult {
  constructor(user) {
    super();
    this.user = user;
  }
}
class ChannelNotInvitableError extends ChatKittyError {
  constructor(channel) {
    super('ChannelNotInvitableError', `The channel ${channel.name} does not accept invites.`);
    this.channel = channel;
  }
}
class UpdatedChannelResult extends ChatKittySucceededResult {
  constructor(channel) {
    super();
    this.channel = channel;
  }
}
class DeletedChannelResult extends ChatKittySucceededResult {
  constructor() {
    super();
  }
}
class StartedChatSessionResult extends ChatKittySucceededResult {
  constructor(session) {
    super();
    this.session = session;
  }
}
class RetrieveCurrentUserSuccessfulResult extends ChatKittySucceededResult {
  constructor(user) {
    super();
    this.user = user;
  }
}
class UpdatedCurrentUserResult extends ChatKittySucceededResult {
  constructor(user) {
    super();
    this.user = user;
  }
}
class UpdatedCurrentUserDisplayPictureResult extends ChatKittySucceededResult {
  constructor(user) {
    super();
    this.user = user;
  }
}
class TriggeredEventResult extends ChatKittySucceededResult {
  constructor(channel) {
    super();
    this.channel = channel;
  }
}
let ChatKittyUploadResult = /*#__PURE__*/function (ChatKittyUploadResult) {
  ChatKittyUploadResult[ChatKittyUploadResult["COMPLETED"] = 0] = "COMPLETED";
  ChatKittyUploadResult[ChatKittyUploadResult["FAILED"] = 1] = "FAILED";
  ChatKittyUploadResult[ChatKittyUploadResult["CANCELLED"] = 2] = "CANCELLED";
  return ChatKittyUploadResult;
}({});
function isTextMessage(message) {
  return message.body !== undefined;
}
function isFileMessage(message) {
  return message.file !== undefined;
}
function isUserMessage(message) {
  return message.user !== undefined;
}
function isSystemMessage(message) {
  return message.user === undefined;
}
class ListMessagesSucceededResult extends ChatKittySucceededResult {
  constructor(paginator) {
    super();
    this.paginator = paginator;
  }
}
class RetrieveLastReadMessageSucceededResult extends ChatKittySucceededResult {
  constructor(message) {
    super();
    this.message = message;
  }
}
class ReadMessageSucceededResult extends ChatKittySucceededResult {
  constructor(message) {
    super();
    this.message = message;
  }
}
class UnreadMessageSucceededResult extends ChatKittySucceededResult {
  constructor(message) {
    super();
    this.message = message;
  }
}
class EditedMessageSucceededResult extends ChatKittySucceededResult {
  constructor(message) {
    super();
    this.message = message;
  }
}
class UpdatedMessagePropertiesSucceededResult extends ChatKittySucceededResult {
  constructor(message) {
    super();
    this.message = message;
  }
}
class DeleteMessageSucceededResult extends ChatKittySucceededResult {
  constructor(message) {
    super();
    this.message = message;
  }
}
class SentTextMessageResult extends ChatKittySucceededResult {
  constructor(message) {
    super();
    this.message = message;
  }
}
class SentFileMessageResult extends ChatKittySucceededResult {
  constructor(message) {
    super();
    this.message = message;
  }
}
function sentTextMessage(result) {
  const message = result.message;
  return message !== undefined && message.type === 'TEXT';
}
function sentFileMessage(result) {
  const message = result.message;
  return message !== undefined && message.type === 'FILE';
}
class RetrieveMessageChannelSucceededResult extends ChatKittySucceededResult {
  constructor(channel) {
    super();
    this.channel = channel;
  }
}
class RetrieveMessageParentSucceededResult extends ChatKittySucceededResult {
  constructor(message) {
    super();
    this.message = message;
  }
}
class MessageNotAReplyError extends ChatKittyError {
  constructor(messageModel) {
    super('MessageNotAReplyError', `Message ${messageModel.id} is not a reply.`);
    this.messageModel = messageModel;
  }
}
function isSystemSentMessageNotification(notification) {
  return notification.data.type === 'SYSTEM:SENT:MESSAGE';
}
function isUserSentMessageNotification(notification) {
  return notification.data.type === 'USER:SENT:MESSAGE';
}
function isUserRepliedToMessageNotification(notification) {
  return notification.data.type === 'USER:REPLIED_TO:MESSAGE';
}
function isUserMentionedNotification(notification) {
  return notification.data.type === 'USER:MENTIONED:USER';
}
function isUserMentionedChannelNotification(notification) {
  return notification.data.type === 'USER:MENTIONED:CHANNEL';
}
class ReactedToMessageResult extends ChatKittySucceededResult {
  constructor(reaction) {
    super();
    this.reaction = reaction;
  }
}
class ListReactionsSucceededResult extends ChatKittySucceededResult {
  constructor(paginator) {
    super();
    this.paginator = paginator;
  }
}
class RemovedReactionResult extends ChatKittySucceededResult {
  constructor(reaction) {
    super();
    this.reaction = reaction;
  }
}
class ListReadReceiptsSucceededResult extends ChatKittySucceededResult {
  constructor(paginator) {
    super();
    this.paginator = paginator;
  }
}
class CreatedThreadResult extends ChatKittySucceededResult {
  constructor(thread) {
    super();
    this.thread = thread;
  }
}
class ListThreadsSucceededResult extends ChatKittySucceededResult {
  constructor(paginator) {
    super();
    this.paginator = paginator;
  }
}
class RetrieveThreadChannelSucceededResult extends ChatKittySucceededResult {
  constructor(channel) {
    super();
    this.channel = channel;
  }
}
class RetrieveThreadMessageSucceededResult extends ChatKittySucceededResult {
  constructor(message) {
    super();
    this.message = message;
  }
}
class ReadThreadSucceededResult extends ChatKittySucceededResult {
  constructor(thread) {
    super();
    this.thread = thread;
  }
}
class ListUsersSucceededResult extends ChatKittySucceededResult {
  constructor(paginator) {
    super();
    this.paginator = paginator;
  }
}
class ListUserSucceededResult extends ChatKittySucceededResult {
  constructor(user) {
    super();
    this.user = user;
  }
}
class CheckUserIsChannelMemberSucceededResult extends ChatKittySucceededResult {
  constructor(isChannelMember) {
    super();
    this.isChannelMember = isChannelMember;
  }
}
class BlockUserSucceededResult extends ChatKittySucceededResult {
  constructor(user) {
    super();
    this.user = user;
  }
}
class ListUserBlockedRecordsSucceededResult extends ChatKittySucceededResult {
  constructor(paginator) {
    super();
    this.paginator = paginator;
  }
}
class DeleteUserBlockedRecordSucceededResult extends ChatKittySucceededResult {
  constructor(user) {
    super();
    this.user = user;
  }
}
class StartedSessionResult extends ChatKittySucceededResult {
  constructor(session) {
    super();
    this.session = session;
  }
}
class SessionActiveError extends ChatKittyError {
  constructor() {
    super('SessionActiveError', 'A user session is already active and must be ended before this instance can start a new session.');
  }
}
class NoActiveSessionError extends ChatKittyError {
  constructor() {
    super('NoActiveSessionError', "You're not connected to ChatKitty.");
  }
}
class ChatKittyPaginator {
  /** @internal */
  static async createInstance(request) {
    const page = await new Promise((resolve, reject) => {
      const destination = request.relay.replace('.size..sort.', `.size.${request.size || ''}.sort.${request.sort || ''}`);
      request.stompX.relayResource({
        destination: destination,
        parameters: request.parameters,
        onSuccess: resource => resolve(resource),
        onError: error => reject(error)
      });
    });
    let items = [];
    if (page._embedded) {
      items = page._embedded[request.contentName];
    }
    const mapper = request.mapper;
    const asyncMapper = request.asyncMapper;
    if (mapper) {
      items = items.map(item => mapper(item));
    } else if (asyncMapper) {
      const mappedItems = [];
      for (const item of items) {
        mappedItems.concat(await asyncMapper(item));
      }
      items = mappedItems;
    }
    return new ChatKittyPaginator(items, page.page, request.stompX, request.contentName, page._relays.prev, page._relays.next, request.parameters, mapper, asyncMapper);
  }
  constructor(items, page, stompX, contentName, prevRelay, nextRelay, parameters, mapper, asyncMapper) {
    this.items = items;
    this.page = page;
    this.stompX = stompX;
    this.contentName = contentName;
    this.prevRelay = prevRelay;
    this.nextRelay = nextRelay;
    this.parameters = parameters;
    this.mapper = mapper;
    this.asyncMapper = asyncMapper;
  }
  get hasPrevPage() {
    return !!this.prevRelay;
  }
  get hasNextPage() {
    return !!this.nextRelay;
  }
  async prevPage() {
    return this.getPage(this.prevRelay);
  }
  async nextPage() {
    return this.getPage(this.nextRelay);
  }
  async getPage(relay) {
    const page = await new Promise((resolve, reject) => {
      if (relay) {
        this.stompX.relayResource({
          destination: relay,
          parameters: this.parameters,
          onSuccess: resource => resolve(resource),
          onError: error => reject(error)
        });
      } else {
        reject(new PageOutOfBoundsError());
      }
    });
    let items = [];
    if (page._embedded) {
      items = page._embedded[this.contentName];
    }
    const mapper = this.mapper;
    const asyncMapper = this.asyncMapper;
    if (mapper) {
      items = items.map(item => mapper(item));
    } else if (asyncMapper) {
      const mappedItems = [];
      for (const item of items) {
        mappedItems.concat(await asyncMapper(item));
      }
      items = mappedItems;
    }
    return new ChatKittyPaginator(items, page.page, this.stompX, this.contentName, page._relays.prev, page._relays.next, this.parameters, this.mapper, this.asyncMapper);
  }
}
class PageOutOfBoundsError extends ChatKittyError {
  constructor() {
    super('PageOutOfBoundsError', "You've requested a page that doesn't exists.");
  }
}
const environment = {
  production: true
};

// Generated by genversion.
const version = '0.0.0-semantic-release';
const TransportFallback = sockjs;
class StompX {
  host;
  wsScheme;
  httpScheme;
  rxStompConfig;
  axios;
  topics = (() => new Map())();
  pendingActions = (() => new Map())();
  pendingRelayErrors = (() => new Map())();
  pendingActionErrors = (() => new Map())();
  eventHandlers = (() => new Map())();
  rxStomp = (() => new RxStomp())();
  initialized = false;
  constructor(configuration) {
    this.host = configuration.host;
    if (configuration.isSecure) {
      this.wsScheme = 'wss';
      this.httpScheme = 'https';
    } else {
      this.wsScheme = 'ws';
      this.httpScheme = 'http';
    }
    this.rxStompConfig = {
      stompVersions: new Versions(['1.2']),
      connectionTimeout: 60000,
      heartbeatIncoming: 10000,
      heartbeatOutgoing: 60000,
      debug: message => {
        if (configuration.isDebug) {
          console.log('StompX Debug:\n' + message);
        }
      }
    };
    if (typeof navigator != 'undefined' && navigator.product == 'ReactNative') {
      this.rxStompConfig.forceBinaryWSFrames = true;
      this.rxStompConfig.appendMissingNULLonIncoming = true;
    }
    this.axios = Axios.create({
      baseURL: this.httpScheme + '://' + this.host
    });
  }
  connect(request) {
    const host = this.host;
    const connectHeaders = {
      'StompX-User': request.username,
      'StompX-User-Agent': `ChatKitty-JS-Core/${version}`
    };
    if (request.authParams) {
      connectHeaders['StompX-Auth-Params'] = encode(JSON.stringify(request.authParams));
    }
    if (typeof WebSocket === 'function') {
      this.rxStompConfig.brokerURL = `${this.wsScheme}://${host}/rtm/websocket?api-key=${encodeURIComponent(request.apiKey)}`;
    } else {
      this.rxStompConfig.webSocketFactory = () => {
        return new TransportFallback(`${this.httpScheme}://${host}/rtm?api-key=${encodeURIComponent(request.apiKey)}`);
      };
    }
    this.rxStomp.configure(_objectSpread(_objectSpread({}, this.rxStompConfig), {}, {
      connectHeaders
    }));
    this.rxStomp.serverHeaders$.subscribe(headers => {
      this.rxStomp.configure(_objectSpread(_objectSpread({}, this.rxStompConfig), {}, {
        connectHeaders: _objectSpread(_objectSpread({}, connectHeaders), {}, {
          'StompX-Auth-Session-ID': headers['session']
        })
      }));
    });
    this.rxStomp.connected$.subscribe(() => {
      this.relayResource({
        destination: '/application/v1/user.relay',
        onSuccess: user => {
          if (this.initialized) {
            request.onConnected(user);
          } else {
            this.rxStomp.watch('/user/queue/v1/errors', {
              id: StompX.generateSubscriptionId()
            }).subscribe(message => {
              const error = JSON.parse(message.body);
              const subscription = message.headers['subscription-id'];
              const receipt = message.headers['receipt-id'];
              if (subscription) {
                const handler = this.pendingRelayErrors.get(subscription);
                if (handler) {
                  handler(error);
                  this.pendingRelayErrors.delete(subscription);
                }
              }
              if (receipt) {
                const handler = this.pendingActionErrors.get(receipt);
                if (handler) {
                  handler(error);
                  this.pendingActionErrors.delete(receipt);
                }
              }
              if (!subscription && !receipt) {
                this.pendingActionErrors.forEach(handler => {
                  handler(error);
                });
                this.pendingActionErrors.clear();
              }
            });
            this.relayResource({
              destination: '/application/v1/user.write_file_access_grant.relay',
              onSuccess: write => {
                this.relayResource({
                  destination: '/application/v1/user.read_file_access_grant.relay',
                  onSuccess: read => {
                    request.onSuccess(user, write.grant, read.grant);
                    request.onConnected(user);
                    this.initialized = true;
                  }
                });
              }
            });
          }
        }
      });
    });
    this.rxStomp.connectionState$.subscribe(state => {
      if (state == RxStompState.CLOSED) {
        request.onConnectionLost();
      }
      if (state == RxStompState.OPEN) {
        request.onConnectionResumed();
      }
    });
    this.rxStomp.stompErrors$.subscribe(frame => {
      let error;
      try {
        error = JSON.parse(frame.body);
      } catch (e) {
        error = {
          error: 'UnknownChatKittyError',
          message: 'An unknown error occurred.',
          timestamp: new Date().toISOString()
        };
      }
      if (error.error == 'AccessDeniedError') {
        const onResult = () => request.onError(error);
        this.disconnect().then(onResult, onResult);
      } else {
        request.onError(error);
      }
    });
    this.rxStomp.webSocketErrors$.subscribe(error => {
      console.error(error);
      request.onError({
        error: 'ChatKittyConnectionError',
        message: 'Could not connect to ChatKitty',
        timestamp: new Date().toISOString()
      });
    });
    this.rxStomp.activate();
  }
  relayResource(request) {
    this.guardConnected(() => {
      const subscriptionId = StompX.generateSubscriptionId();
      if (request.onError) {
        this.pendingRelayErrors.set(subscriptionId, request.onError);
      }
      this.rxStomp.stompClient.subscribe(request.destination, message => {
        request.onSuccess(JSON.parse(message.body).resource);
      }, _objectSpread(_objectSpread({}, request.parameters), {}, {
        id: subscriptionId
      }));
    });
  }
  listenToTopic(request) {
    let unsubscribe = () => {
      // Do nothing
    };
    this.guardConnected(() => {
      const subscriptionReceipt = StompX.generateReceipt();
      const onSuccess = request.onSuccess;
      if (onSuccess) {
        this.rxStomp.watchForReceipt(subscriptionReceipt, () => {
          onSuccess();
        });
      }
      const subscription = this.rxStomp.watch(request.topic, {
        id: StompX.generateSubscriptionId(),
        receipt: subscriptionReceipt,
        ack: 'client-individual'
      }).subscribe(message => {
        const event = JSON.parse(message.body);
        const receipt = message.headers['receipt-id'];
        if (receipt) {
          const action = this.pendingActions.get(receipt);
          if (action && (!action.types || action.types.find(type => type === event.type))) {
            action.action(event.resource);
            this.pendingActions.delete(receipt);
          }
        }
        const handlers = this.eventHandlers.get(request.topic);
        if (handlers) {
          handlers.forEach(handler => {
            if (handler.event === event.type) {
              handler.onSuccess(event.resource);
            }
          });
        }
        message.ack();
      });
      this.topics.set(request.topic, subscription);
      unsubscribe = () => {
        subscription.unsubscribe();
        this.topics.delete(request.topic);
      };
    });
    return () => unsubscribe();
  }
  listenForEvent(request) {
    let handlers = this.eventHandlers.get(request.topic);
    if (handlers === undefined) {
      handlers = new Set();
    }
    const handler = {
      event: request.event,
      onSuccess: request.onSuccess
    };
    handlers.add(handler);
    this.eventHandlers.set(request.topic, handlers);
    return () => {
      if (handlers) {
        handlers.delete(handler);
      }
    };
  }
  sendAction(request) {
    this.guardConnected(() => {
      const receipt = StompX.generateReceipt();
      if (request.onSent) {
        this.rxStomp.watchForReceipt(receipt, request.onSent);
      }
      if (request.onSuccess) {
        this.pendingActions.set(receipt, {
          types: request.events,
          action: request.onSuccess
        });
      }
      if (request.onError) {
        this.pendingActionErrors.set(receipt, request.onError);
      }
      this.rxStomp.publish({
        destination: request.destination,
        headers: {
          'content-type': 'application/json;charset=UTF-8',
          receipt: receipt
        },
        body: JSON.stringify(request.body)
      });
    });
  }
  sendToStream(request) {
    const data = new FormData();
    let file = request.file;
    if (!(file instanceof File)) {
      file = StompX.dataUriToFile(file.uri, file.name);
    }
    data.append('file', file);
    request.properties?.forEach((value, key) => {
      data.append(key, JSON.stringify(value));
    });
    request.progressListener?.onStarted?.();
    this.axios({
      method: 'post',
      url: request.stream,
      data: data,
      headers: {
        'Content-Type': 'multipart/form-data',
        Grant: request.grant
      },
      onUploadProgress: progressEvent => {
        request.progressListener?.onProgress?.(progressEvent.loaded / (progressEvent?.total || 1));
      }
    }).then(response => {
      request.progressListener?.onCompleted?.();
      request.onSuccess?.(response.data);
    }).catch(error => {
      request.progressListener?.onFailed?.();
      request.onError?.(error);
    });
  }
  async disconnect() {
    this.topics.forEach(subscription => {
      subscription.unsubscribe();
    });
    this.topics.clear();
    this.pendingActions.clear();
    this.pendingActionErrors.clear();
    this.pendingRelayErrors.clear();
    this.eventHandlers.clear();
    this.initialized = false;
    await this.rxStomp.deactivate();
    this.rxStomp = new RxStomp();
  }
  guardConnected(action) {
    this.rxStomp.connected$.pipe(take(1)).subscribe(() => {
      action();
    });
  }
  static dataUriToFile(url, name) {
    const arr = url.split(','),
      mime = arr[0].match(/:(.*?);/)?.[1],
      bstr = atob(arr[1]);
    let n = bstr.length;
    const u8arr = new Uint8Array(n);
    while (n--) {
      u8arr[n] = bstr.charCodeAt(n);
    }
    return new File([u8arr], name, {
      type: mime
    });
  }
  static generateSubscriptionId() {
    return 'subscription-id-' + v4();
  }
  static generateReceipt() {
    return 'receipt-' + v4();
  }
}
class ChatKitty {
  static _instances = (() => new Map())();
  static getInstance(apiKey) {
    let instance = ChatKitty._instances.get(apiKey);
    if (instance !== undefined) {
      return instance;
    }
    instance = new ChatKitty({
      apiKey: apiKey
    });
    ChatKitty._instances.set(apiKey, instance);
    return instance;
  }
  static channelRelay(id) {
    return '/application/v1/channels/' + id + '.relay';
  }
  static userRelay(id) {
    return '/application/v1/users/' + id + '.relay';
  }
  stompX;
  currentUserSubject = (() => new BehaviorSubject(null))();
  lostConnectionSubject = (() => new Subject())();
  resumedConnectionSubject = (() => new Subject())();
  writeFileGrant;
  chatSessions = (() => new Map())();
  messageMapper = (() => new MessageMapper(''))();
  keyStrokesSubject = (() => new Subject())();
  currentUser;
  constructor(configuration) {
    this.configuration = configuration;
    this.stompX = new StompX({
      isSecure: configuration.isSecure === undefined || configuration.isSecure,
      host: configuration.host || 'api.chatkitty.com',
      isDebug: !environment.production
    });
    this.keyStrokesSubject.asObservable().pipe(debounceTime(150)).subscribe(request => {
      let destination = '';
      const channel = request.channel;
      const thread = request.thread;
      if (channel) {
        destination = channel._actions.keystrokes;
      }
      if (thread) {
        destination = thread._actions.keystrokes;
      }
      this.stompX.sendAction({
        destination,
        body: {
          keys: request.keys
        }
      });
    });
  }
  startSession(request) {
    if (this.stompX.initialized) {
      throw new SessionActiveError();
    }
    return new Promise(resolve => {
      this.stompX.connect({
        apiKey: this.configuration.apiKey,
        username: request.username,
        authParams: request.authParams,
        onSuccess: (user, writeFileGrant, readFileGrant) => {
          this.stompX.listenToTopic({
            topic: user._topics.self
          });
          this.stompX.listenToTopic({
            topic: user._topics.channels
          });
          this.stompX.listenToTopic({
            topic: user._topics.messages
          });
          this.stompX.listenToTopic({
            topic: user._topics.notifications
          });
          this.stompX.listenToTopic({
            topic: user._topics.contacts
          });
          this.stompX.listenToTopic({
            topic: user._topics.participants
          });
          this.stompX.listenToTopic({
            topic: user._topics.users
          });
          this.stompX.listenToTopic({
            topic: user._topics.reactions
          });
          this.stompX.listenToTopic({
            topic: user._topics.threads
          });
          this.stompX.listenToTopic({
            topic: user._topics.calls
          });
          this.writeFileGrant = writeFileGrant;
          this.messageMapper = new MessageMapper(readFileGrant);
          resolve(new StartedSessionResult({
            user: user
          }));
        },
        onConnected: user => {
          this.currentUser = user;
          this.currentUserSubject.next(user);
        },
        onConnectionLost: () => this.lostConnectionSubject.next(),
        onConnectionResumed: () => this.resumedConnectionSubject.next(),
        onError: error => {
          resolve(new ChatKittyFailedResult(error));
        }
      });
    });
  }
  async endSession() {
    await this.stompX.disconnect();
    this.currentUser = undefined;
    this.currentUserSubject.next(null);
  }
  retrieveCurrentUser() {
    const currentUser = this.currentUser;
    if (!currentUser) {
      throw new NoActiveSessionError();
    }
    return new Promise(resolve => {
      this.stompX.relayResource({
        destination: currentUser._relays.self,
        onSuccess: user => {
          resolve(new RetrieveCurrentUserSuccessfulResult(user));
        },
        onError: error => {
          resolve(new ChatKittyFailedResult(error));
        }
      });
    });
  }
  onCurrentUserChanged(onNextOrObserver) {
    const subscription = this.currentUserSubject.subscribe(user => {
      if (typeof onNextOrObserver === 'function') {
        onNextOrObserver(user);
      } else {
        onNextOrObserver.onNext(user);
      }
    });
    return () => subscription.unsubscribe();
  }
  onCurrentUserOnline(onNextOrObserver) {
    const subscription = this.resumedConnectionSubject.subscribe(() => {
      if (typeof onNextOrObserver === 'function') {
        onNextOrObserver();
      } else {
        if (this.currentUser) {
          onNextOrObserver.onNext(this.currentUser);
        }
      }
    });
    return () => subscription.unsubscribe();
  }
  onCurrentUserOffline(onNextOrObserver) {
    const subscription = this.lostConnectionSubject.subscribe(() => {
      if (typeof onNextOrObserver === 'function') {
        onNextOrObserver();
      } else {
        if (this.currentUser) {
          onNextOrObserver.onNext(this.currentUser);
        }
      }
    });
    return () => subscription.unsubscribe();
  }
  updateCurrentUser(update) {
    const currentUser = this.currentUser;
    if (!currentUser) {
      throw new NoActiveSessionError();
    }
    return new Promise(resolve => {
      this.stompX.sendAction({
        destination: currentUser._actions.update,
        body: update(currentUser),
        onSuccess: user => {
          this.currentUserSubject.next(user);
          resolve(new UpdatedCurrentUserResult(user));
        },
        onError: error => {
          resolve(new ChatKittyFailedResult(error));
        }
      });
    });
  }
  updateCurrentUserDisplayPicture(request) {
    const currentUser = this.currentUser;
    if (!currentUser) {
      throw new NoActiveSessionError();
    }
    return new Promise(resolve => {
      const file = request.file;
      if (file.uri) {
        this.stompX.sendToStream({
          stream: currentUser._streams.displayPicture,
          grant: this.writeFileGrant,
          file: file,
          onSuccess: user => {
            resolve(new UpdatedCurrentUserDisplayPictureResult(user));
          },
          onError: error => {
            resolve(new ChatKittyFailedResult(error));
          },
          progressListener: {
            onStarted: () => request.progressListener?.onStarted?.(),
            onProgress: progress => request.progressListener?.onProgress(progress),
            onCompleted: () => request.progressListener?.onCompleted(ChatKittyUploadResult.COMPLETED),
            onFailed: () => request.progressListener?.onCompleted(ChatKittyUploadResult.FAILED),
            onCancelled: () => request.progressListener?.onCompleted(ChatKittyUploadResult.CANCELLED)
          }
        });
      } else {
        this.stompX.sendAction({
          destination: currentUser._actions.updateDisplayPicture,
          body: file,
          onSuccess: user => {
            resolve(new UpdatedCurrentUserResult(user));
          },
          onError: error => {
            resolve(new ChatKittyFailedResult(error));
          }
        });
      }
    });
  }
  updateChannel(request) {
    return new Promise(resolve => {
      this.stompX.sendAction({
        destination: request.channel._actions.update,
        body: request.channel,
        onSuccess: channel => {
          resolve(new UpdatedChannelResult(channel));
        },
        onError: error => {
          resolve(new ChatKittyFailedResult(error));
        }
      });
    });
  }
  deleteChannel(request) {
    return new Promise(resolve => {
      this.stompX.sendAction({
        destination: request.channel._actions.delete,
        body: {},
        onSuccess: () => {
          resolve(new DeletedChannelResult());
        },
        onError: error => {
          resolve(new ChatKittyFailedResult(error));
        }
      });
    });
  }
  createChannel(request) {
    const currentUser = this.currentUser;
    if (!currentUser) {
      throw new NoActiveSessionError();
    }
    return new Promise(resolve => {
      this.stompX.sendAction({
        destination: currentUser._actions.createChannel,
        events: ['user.channel.created', 'user.channel.upserted', 'member.channel.upserted'],
        body: request,
        onSuccess: channel => {
          resolve(new CreatedChannelResult(channel));
        },
        onError: error => {
          resolve(new ChatKittyFailedResult(error));
        }
      });
    });
  }
  listChannels(request) {
    const currentUser = this.currentUser;
    if (!currentUser) {
      throw new NoActiveSessionError();
    }
    return new Promise(resolve => {
      const parameters = {};
      let relay = currentUser._relays.channels;
      if (isListChannelsRequest(request)) {
        if (request.filter?.joined === false) {
          relay = currentUser._relays.joinableChannels;
        }
        if (request.filter?.joined === true) {
          parameters.subscribable = true;
        }
        if (request.filter?.unread) {
          relay = currentUser._relays.unreadChannels;
        }
      }
      const name = request?.filter?.name;
      if (name) {
        parameters.name = name;
      }
      ChatKittyPaginator.createInstance({
        stompX: this.stompX,
        relay: relay,
        contentName: 'channels',
        parameters: parameters,
        size: request?.size,
        sort: request?.sort
      }).then(paginator => resolve(new ListChannelsSucceededResult(paginator))).catch(error => resolve(new ChatKittyFailedResult(error)));
    });
  }
  retrieveChannel(id) {
    return new Promise(resolve => {
      this.stompX.relayResource({
        destination: ChatKitty.channelRelay(id),
        onSuccess: channel => {
          resolve(new RetrieveChannelSucceededResult(channel));
        },
        onError: error => {
          resolve(new ChatKittyFailedResult(error));
        }
      });
    });
  }
  retrieveChannelContext(request) {
    return new Promise(resolve => {
      this.stompX.relayResource({
        destination: request.channel._relays.context,
        parameters: {
          startCursor: request.startCursor,
          endCursor: request.endCursor
        },
        onSuccess: context => {
          resolve(new RetrieveChannelContextSucceededResult(context));
        },
        onError: error => {
          resolve(new ChatKittyFailedResult(error));
        }
      });
    });
  }
  joinChannel(request) {
    const currentUser = this.currentUser;
    if (!currentUser) {
      throw new NoActiveSessionError();
    }
    const destination = request.channel._actions.join;
    if (!destination) {
      throw new ChannelNotPubliclyJoinableError(request.channel);
    }
    return new Promise(resolve => {
      this.stompX.sendAction({
        destination: destination,
        body: request,
        onSuccess: channel => {
          resolve(new JoinedChannelResult(channel));
        },
        onError: error => {
          resolve(new ChatKittyFailedResult(error));
        }
      });
    });
  }
  leaveChannel(request) {
    const currentUser = this.currentUser;
    if (!currentUser) {
      throw new NoActiveSessionError();
    }
    const destination = request.channel._actions.leave;
    if (!destination) {
      throw new NotAChannelMemberError(request.channel);
    }
    return new Promise(resolve => {
      this.stompX.sendAction({
        destination: destination,
        body: {},
        onSuccess: channel => {
          resolve(new LeftChannelResult(channel));
        },
        onError: error => {
          resolve(new ChatKittyFailedResult(error));
        }
      });
    });
  }
  addChannelModerator(request) {
    const destination = request.channel._actions.addModerator;
    if (!destination) {
      throw new CannotAddModeratorToChannelError(request.channel);
    }
    return new Promise(resolve => {
      this.stompX.sendAction({
        destination: destination,
        body: request.user,
        onSuccess: channel => {
          resolve(new AddedChannelModeratorResult(channel));
        },
        onError: error => {
          resolve(new ChatKittyFailedResult(error));
        }
      });
    });
  }
  countUnreadChannels(request) {
    const currentUser = this.currentUser;
    if (!currentUser) {
      throw new NoActiveSessionError();
    }
    const parameters = {
      unread: true
    };
    if (isListChannelsUnreadRequest(request)) {
      parameters.type = request.filter?.type;
    }
    return new Promise(resolve => {
      this.stompX.relayResource({
        destination: currentUser._relays.channelsCount,
        parameters: parameters,
        onSuccess: resource => {
          resolve(new CountSucceededResult(resource.count));
        },
        onError: error => {
          resolve(new ChatKittyFailedResult(error));
        }
      });
    });
  }
  checkChannelUnread(request) {
    const currentUser = this.currentUser;
    if (!currentUser) {
      throw new NoActiveSessionError();
    }
    return new Promise(resolve => {
      this.stompX.relayResource({
        destination: request.channel._relays.unread,
        onSuccess: resource => {
          resolve(new CheckChannelUnreadSucceededResult(resource.exists));
        },
        onError: error => {
          resolve(new ChatKittyFailedResult(error));
        }
      });
    });
  }
  readChannel(request) {
    const currentUser = this.currentUser;
    if (!currentUser) {
      throw new NoActiveSessionError();
    }
    return new Promise(resolve => {
      this.stompX.sendAction({
        destination: request.channel._actions.read,
        body: {},
        onSent: () => resolve(new ReadChannelSucceededResult(request.channel)),
        onError: error => resolve(new ChatKittyFailedResult(error))
      });
    });
  }
  muteChannel(request) {
    const currentUser = this.currentUser;
    if (!currentUser) {
      throw new NoActiveSessionError();
    }
    return new Promise(resolve => {
      this.stompX.sendAction({
        destination: request.channel._actions.mute,
        body: {
          state: 'ON'
        },
        onSuccess: channel => {
          resolve(new MutedChannelResult(channel));
        },
        onError: error => {
          resolve(new ChatKittyFailedResult(error));
        }
      });
    });
  }
  unmuteChannel(request) {
    const currentUser = this.currentUser;
    if (!currentUser) {
      throw new NoActiveSessionError();
    }
    return new Promise(resolve => {
      this.stompX.sendAction({
        destination: request.channel._actions.mute,
        body: {
          state: 'OFF'
        },
        onSuccess: channel => {
          resolve(new UnmutedChannelResult(channel));
        },
        onError: error => {
          resolve(new ChatKittyFailedResult(error));
        }
      });
    });
  }
  clearChannelHistory(request) {
    const currentUser = this.currentUser;
    if (!currentUser) {
      throw new NoActiveSessionError();
    }
    return new Promise(resolve => {
      this.stompX.sendAction({
        destination: request.channel._actions.clearHistory,
        body: {},
        onSuccess: channel => resolve(new ClearChannelHistorySucceededResult(channel)),
        onError: error => resolve(new ChatKittyFailedResult(error))
      });
    });
  }
  hideChannel(request) {
    return new Promise(resolve => {
      this.stompX.sendAction({
        destination: request.channel._actions.hide,
        body: {},
        onSuccess: resource => resolve(new HideChannelSucceededResult(resource)),
        onError: error => resolve(new ChatKittyFailedResult(error))
      });
    });
  }
  startChatSession(request) {
    const onMessageReceived = request.onMessageReceived;
    const onKeystrokesReceived = request.onKeystrokesReceived;
    const onParticipantEnteredChat = request.onParticipantEnteredChat;
    const onParticipantLeftChat = request.onParticipantLeftChat;
    const onTypingStarted = request.onTypingStarted;
    const onTypingStopped = request.onTypingStopped;
    const onParticipantPresenceChanged = request.onParticipantPresenceChanged;
    const onEventTriggered = request.onEventTriggered;
    const onMessageUpdated = request.onMessageUpdated;
    const onMessageDeleted = request.onMessageDeleted;
    const onChannelUpdated = request.onChannelUpdated;
    const onMessageRead = request.onMessageRead;
    const onMessageUnread = request.onMessageUnread;
    const onMessageReactionAdded = request.onMessageReactionAdded;
    const onMessageReactionRemoved = request.onMessageReactionRemoved;
    const onThreadMessageReceived = request.onThreadMessageReceived;
    const onThreadKeystrokesReceived = request.onThreadKeystrokesReceived;
    const onThreadTypingStarted = request.onThreadTypingStarted;
    const onThreadTypingStopped = request.onThreadTypingStopped;
    let messageReceivedUnsubscribe;
    let keystrokesReceivedUnsubscribe;
    let participantEnteredChatUnsubscribe;
    let participantLeftChatUnsubscribe;
    let typingStartedUnsubscribe;
    let typingStoppedUnsubscribe;
    let participantPresenceChangedUnsubscribe;
    let eventTriggeredUnsubscribe;
    let messageUpdatedUnsubscribe;
    let messageDeletedUnsubscribe;
    let channelUpdatedUnsubscribe;
    let messageReadUnsubscribe;
    let messageReactionAddedUnsubscribe;
    let messageReactionRemovedUnsubscribe;
    let threadMessageReceivedUnsubscribe;
    let threadKeystrokesReceivedUnsubscribe;
    let threadTypingStartedUnsubscribe;
    let threadTypingStoppedUnsubscribe;
    if (onMessageReceived) {
      messageReceivedUnsubscribe = this.stompX.listenForEvent({
        topic: request.channel._topics.messages,
        event: 'channel.message.created',
        onSuccess: message => {
          const destination = message._relays.parent;
          if (destination) {
            this.stompX.relayResource({
              destination,
              onSuccess: parent => {
                onMessageReceived(this.messageMapper.map(message), this.messageMapper.map(parent));
              }
            });
          } else {
            onMessageReceived(this.messageMapper.map(message));
          }
        }
      });
    }
    if (onKeystrokesReceived) {
      keystrokesReceivedUnsubscribe = this.stompX.listenForEvent({
        topic: request.channel._topics.keystrokes,
        event: 'thread.keystrokes.created',
        onSuccess: keystrokes => {
          onKeystrokesReceived(keystrokes);
        }
      });
    }
    if (onTypingStarted) {
      typingStartedUnsubscribe = this.stompX.listenForEvent({
        topic: request.channel._topics.typing,
        event: 'thread.typing.started',
        onSuccess: user => {
          onTypingStarted(user);
        }
      });
    }
    if (onTypingStopped) {
      typingStoppedUnsubscribe = this.stompX.listenForEvent({
        topic: request.channel._topics.typing,
        event: 'thread.typing.stopped',
        onSuccess: user => {
          onTypingStopped(user);
        }
      });
    }
    if (onParticipantEnteredChat) {
      participantEnteredChatUnsubscribe = this.stompX.listenForEvent({
        topic: request.channel._topics.participants,
        event: 'channel.participant.active',
        onSuccess: user => {
          onParticipantEnteredChat(user);
        }
      });
    }
    if (onParticipantLeftChat) {
      participantLeftChatUnsubscribe = this.stompX.listenForEvent({
        topic: request.channel._topics.participants,
        event: 'channel.participant.inactive',
        onSuccess: user => {
          onParticipantLeftChat(user);
        }
      });
    }
    if (onParticipantPresenceChanged) {
      participantPresenceChangedUnsubscribe = this.stompX.listenForEvent({
        topic: request.channel._topics.participants,
        event: 'participant.presence.changed',
        onSuccess: user => {
          onParticipantPresenceChanged(user);
        }
      });
    }
    if (onMessageUpdated) {
      messageUpdatedUnsubscribe = this.stompX.listenForEvent({
        topic: request.channel._topics.messages,
        event: 'channel.message.updated',
        onSuccess: message => {
          onMessageUpdated(message);
        }
      });
    }
    if (onMessageDeleted) {
      messageDeletedUnsubscribe = this.stompX.listenForEvent({
        topic: request.channel._topics.messages,
        event: 'channel.message.deleted',
        onSuccess: message => {
          onMessageDeleted(message);
        }
      });
    }
    if (onEventTriggered) {
      eventTriggeredUnsubscribe = this.stompX.listenForEvent({
        topic: request.channel._topics.events,
        event: 'channel.event.triggered',
        onSuccess: event => {
          onEventTriggered(event);
        }
      });
    }
    if (onChannelUpdated) {
      channelUpdatedUnsubscribe = this.stompX.listenForEvent({
        topic: request.channel._topics.self,
        event: 'channel.self.updated',
        onSuccess: channel => {
          onChannelUpdated(channel);
        }
      });
    }
    if (onMessageRead) {
      messageReadUnsubscribe = this.stompX.listenForEvent({
        topic: request.channel._topics.readReceipts,
        event: 'message.read_receipt.created',
        onSuccess: receipt => {
          this.stompX.relayResource({
            destination: receipt._relays.message,
            onSuccess: message => {
              onMessageRead(message, receipt);
            }
          });
        }
      });
    }
    if (onMessageUnread) {
      messageReadUnsubscribe = this.stompX.listenForEvent({
        topic: request.channel._topics.readReceipts,
        event: 'message.read_receipt.deleted',
        onSuccess: receipt => {
          this.stompX.relayResource({
            destination: receipt._relays.message,
            onSuccess: message => {
              onMessageUnread(message, receipt);
            }
          });
        }
      });
    }
    if (onMessageReactionAdded) {
      messageReactionAddedUnsubscribe = this.stompX.listenForEvent({
        topic: request.channel._topics.reactions,
        event: 'message.reaction.created',
        onSuccess: reaction => {
          this.stompX.relayResource({
            destination: reaction._relays.message,
            onSuccess: message => {
              onMessageReactionAdded(message, reaction);
            }
          });
        }
      });
    }
    if (onMessageReactionRemoved) {
      messageReactionRemovedUnsubscribe = this.stompX.listenForEvent({
        topic: request.channel._topics.reactions,
        event: 'message.reaction.removed',
        onSuccess: reaction => {
          this.stompX.relayResource({
            destination: reaction._relays.message,
            onSuccess: message => {
              onMessageReactionRemoved(message, reaction);
            }
          });
        }
      });
    }
    let end = () => {
      messageReactionRemovedUnsubscribe?.();
      messageReactionAddedUnsubscribe?.();
      messageReadUnsubscribe?.();
      channelUpdatedUnsubscribe?.();
      messageUpdatedUnsubscribe?.();
      messageDeletedUnsubscribe?.();
      eventTriggeredUnsubscribe?.();
      participantPresenceChangedUnsubscribe?.();
      participantLeftChatUnsubscribe?.();
      participantEnteredChatUnsubscribe?.();
      typingStoppedUnsubscribe?.();
      typingStartedUnsubscribe?.();
      keystrokesReceivedUnsubscribe?.();
      messageReceivedUnsubscribe?.();
      threadMessageReceivedUnsubscribe?.();
      threadKeystrokesReceivedUnsubscribe?.();
      threadTypingStartedUnsubscribe?.();
      threadTypingStoppedUnsubscribe?.();
    };
    const channelUnsubscribe = this.stompX.listenToTopic({
      topic: request.channel._topics.self,
      onSuccess: () => {
        const messagesUnsubscribe = this.stompX.listenToTopic({
          topic: request.channel._topics.messages
        });
        const keystrokesUnsubscribe = this.stompX.listenToTopic({
          topic: request.channel._topics.keystrokes
        });
        const typingUnsubscribe = this.stompX.listenToTopic({
          topic: request.channel._topics.typing
        });
        const participantsUnsubscribe = this.stompX.listenToTopic({
          topic: request.channel._topics.participants
        });
        const readReceiptsUnsubscribe = this.stompX.listenToTopic({
          topic: request.channel._topics.readReceipts
        });
        const reactionsUnsubscribe = this.stompX.listenToTopic({
          topic: request.channel._topics.reactions
        });
        const eventsUnsubscribe = this.stompX.listenToTopic({
          topic: request.channel._topics.events
        });
        const superEnd = end;
        end = () => {
          superEnd();
          eventsUnsubscribe?.();
          reactionsUnsubscribe?.();
          readReceiptsUnsubscribe?.();
          participantsUnsubscribe?.();
          typingUnsubscribe?.();
          keystrokesUnsubscribe?.();
          messagesUnsubscribe?.();
          channelUnsubscribe();
          this.chatSessions.delete(request.channel.id);
        };
      }
    });
    let activeThread = null;
    const session = {
      channel: request.channel,
      thread: activeThread,
      end: () => end(),
      setThread: thread => {
        threadMessageReceivedUnsubscribe?.();
        threadKeystrokesReceivedUnsubscribe?.();
        threadTypingStartedUnsubscribe?.();
        threadTypingStoppedUnsubscribe?.();
        if (onThreadMessageReceived) {
          threadMessageReceivedUnsubscribe = this.stompX.listenForEvent({
            topic: thread._topics.messages,
            event: 'thread.message.created',
            onSuccess: message => {
              onThreadMessageReceived(thread, this.messageMapper.map(message));
            }
          });
        }
        if (onThreadKeystrokesReceived) {
          threadKeystrokesReceivedUnsubscribe = this.stompX.listenForEvent({
            topic: thread._topics.keystrokes,
            event: 'thread.keystrokes.created',
            onSuccess: keystrokes => {
              onThreadKeystrokesReceived(thread, keystrokes);
            }
          });
        }
        if (onThreadTypingStarted) {
          threadTypingStartedUnsubscribe = this.stompX.listenForEvent({
            topic: thread._topics.typing,
            event: 'thread.typing.started',
            onSuccess: user => {
              onThreadTypingStarted(thread, user);
            }
          });
        }
        if (onThreadTypingStopped) {
          threadTypingStoppedUnsubscribe = this.stompX.listenForEvent({
            topic: thread._topics.typing,
            event: 'thread.typing.stopped',
            onSuccess: user => {
              onThreadTypingStopped(thread, user);
            }
          });
        }
        activeThread = thread;
      }
    };
    this.chatSessions.set(request.channel.id, session);
    return new StartedChatSessionResult(session);
  }
  sendMessage(request) {
    const currentUser = this.currentUser;
    if (!currentUser) {
      throw new NoActiveSessionError();
    }
    return new Promise(resolve => {
      let destination = '';
      let stream = '';
      const sendChannelMessageRequest = request;
      if (sendChannelMessageRequest.channel !== undefined) {
        destination = sendChannelMessageRequest.channel._actions.message;
        stream = sendChannelMessageRequest.channel._streams.messages;
      }
      const sendMessageReplyRequest = request;
      if (sendMessageReplyRequest.message !== undefined) {
        destination = sendMessageReplyRequest.message._actions.reply;
        stream = sendMessageReplyRequest.message._streams.replies;
      }
      const sendThreadMessageRequest = request;
      if (sendThreadMessageRequest.thread !== undefined) {
        destination = sendThreadMessageRequest.thread._actions.message;
        stream = sendThreadMessageRequest.thread._streams.messages;
      }
      if (isSendChannelTextMessageRequest(request)) {
        this.stompX.sendAction({
          destination: destination,
          body: {
            type: 'TEXT',
            body: request.body,
            groupTag: request.groupTag,
            properties: request.properties
          },
          onSuccess: message => {
            resolve(new SentTextMessageResult(this.messageMapper.map(message)));
          },
          onError: error => {
            resolve(new ChatKittyFailedResult(error));
          }
        });
      }
      if (isSendChannelFileMessageRequest(request)) {
        const file = request.file;
        if (isCreateChatKittyExternalFileProperties(file)) {
          this.stompX.sendAction({
            destination: destination,
            body: {
              type: 'FILE',
              file: file,
              groupTag: request.groupTag,
              properties: request.properties
            },
            onSuccess: message => {
              resolve(new SentFileMessageResult(this.messageMapper.map(message)));
            },
            onError: error => {
              resolve(new ChatKittyFailedResult(error));
            }
          });
        } else {
          const properties = new Map();
          if (request.groupTag) {
            properties.set('groupTag', request.groupTag);
          }
          if (request.properties) {
            properties.set('properties', request.properties);
          }
          this.stompX.sendToStream({
            stream: stream,
            grant: this.writeFileGrant,
            file: file,
            properties: properties,
            onSuccess: message => {
              resolve(new SentFileMessageResult(this.messageMapper.map(message)));
            },
            onError: error => {
              resolve(new ChatKittyFailedResult(error));
            },
            progressListener: {
              onStarted: () => request.progressListener?.onStarted?.(),
              onProgress: progress => request.progressListener?.onProgress(progress),
              onCompleted: () => request.progressListener?.onCompleted(ChatKittyUploadResult.COMPLETED),
              onFailed: () => request.progressListener?.onCompleted(ChatKittyUploadResult.FAILED),
              onCancelled: () => request.progressListener?.onCompleted(ChatKittyUploadResult.CANCELLED)
            }
          });
        }
      }
    });
  }
  listMessages(request) {
    const currentUser = this.currentUser;
    if (!currentUser) {
      throw new NoActiveSessionError();
    }
    let relay = '';
    let parameters = undefined;
    if (isListUsersMessagesRequest(request)) {
      relay = currentUser._relays.messages;
      parameters = _objectSpread({}, request.filter);
    }
    if (isListChannelMessagesRequest(request)) {
      relay = request.channel._relays.messages;
      parameters = _objectSpread({}, request.filter);
    }
    if (isListMessageRepliesRequest(request)) {
      relay = request.message._relays.replies;
    }
    return new Promise(resolve => {
      ChatKittyPaginator.createInstance({
        stompX: this.stompX,
        relay: relay,
        parameters: parameters,
        contentName: 'messages',
        mapper: message => this.messageMapper.map(message)
      }).then(paginator => resolve(new ListMessagesSucceededResult(paginator))).catch(error => resolve(new ChatKittyFailedResult(error)));
    });
  }
  countUnreadMessages(request) {
    const currentUser = this.currentUser;
    if (!currentUser) {
      throw new NoActiveSessionError();
    }
    let relay = currentUser._relays.unreadMessagesCount;
    if (isCountUnreadMessagesRequest(request)) {
      relay = request.channel._relays.messagesCount;
    }
    return new Promise(resolve => {
      this.stompX.relayResource({
        destination: relay,
        parameters: {
          unread: true
        },
        onSuccess: resource => {
          resolve(new CountSucceededResult(resource.count));
        },
        onError: error => {
          resolve(new ChatKittyFailedResult(error));
        }
      });
    });
  }
  triggerEvent(request) {
    const currentUser = this.currentUser;
    if (!currentUser) {
      throw new NoActiveSessionError();
    }
    return new Promise(resolve => {
      this.stompX.sendAction({
        destination: request.channel._actions.triggerEvent,
        body: {
          type: request.type,
          properties: request.properties
        },
        onSent: () => {
          resolve(new TriggeredEventResult(request.channel));
        },
        onError: error => {
          resolve(new ChatKittyFailedResult(error));
        }
      });
    });
  }
  readMessage(request) {
    return new Promise(resolve => {
      this.stompX.sendAction({
        destination: request.message._actions.read,
        body: {},
        onSent: () => resolve(new ReadMessageSucceededResult(request.message)),
        onError: error => resolve(new ChatKittyFailedResult(error))
      });
    });
  }
  unreadMessage(request) {
    return new Promise(resolve => {
      this.stompX.sendAction({
        destination: request.message._actions.unread,
        body: {},
        onSent: () => resolve(new UnreadMessageSucceededResult(request.message)),
        onError: error => resolve(new ChatKittyFailedResult(error))
      });
    });
  }
  retrieveLastReadMessage(request) {
    return new Promise(resolve => {
      this.stompX.relayResource({
        destination: request.channel._relays.lastReadMessage,
        parameters: {
          username: request.username
        },
        onSuccess: resource => {
          resolve(new RetrieveLastReadMessageSucceededResult(resource));
        },
        onError: error => {
          resolve(new ChatKittyFailedResult(error));
        }
      });
    });
  }
  editMessage(request) {
    return new Promise(resolve => {
      this.stompX.sendAction({
        destination: request.message._actions.edit,
        body: {
          body: request.body
        },
        onSuccess: message => resolve(new EditedMessageSucceededResult(message)),
        onError: error => resolve(new ChatKittyFailedResult(error))
      });
    });
  }
  updateMessageProperties(request) {
    return new Promise(resolve => {
      this.stompX.sendAction({
        destination: request.message._actions.updateProperties,
        body: {
          properties: request.properties
        },
        onSuccess: message => resolve(new UpdatedMessagePropertiesSucceededResult(message)),
        onError: error => resolve(new ChatKittyFailedResult(error))
      });
    });
  }
  countMessageReplies(request) {
    return new Promise(resolve => {
      this.stompX.relayResource({
        destination: request.message._relays.repliesCount,
        onSuccess: resource => {
          resolve(new CountSucceededResult(resource.count));
        },
        onError: error => {
          resolve(new ChatKittyFailedResult(error));
        }
      });
    });
  }
  retrieveMessageChannel(request) {
    return new Promise(resolve => {
      this.stompX.relayResource({
        destination: request.message._relays.channel,
        onSuccess: resource => {
          resolve(new RetrieveMessageChannelSucceededResult(resource));
        },
        onError: error => {
          resolve(new ChatKittyFailedResult(error));
        }
      });
    });
  }
  retrieveMessageParent(request) {
    return new Promise(resolve => {
      const destination = request.message._relays.parent;
      if (!destination) {
        throw new MessageNotAReplyError(request.message);
      }
      this.stompX.relayResource({
        destination,
        onSuccess: resource => {
          resolve(new RetrieveMessageParentSucceededResult(resource));
        },
        onError: error => {
          resolve(new ChatKittyFailedResult(error));
        }
      });
    });
  }
  createThread(request) {
    return new Promise(resolve => {
      this.stompX.sendAction({
        destination: request.channel._actions.createThread,
        body: {
          name: request.name,
          properties: request.properties
        },
        onSuccess: thread => resolve(new CreatedThreadResult(thread)),
        onError: error => resolve(new ChatKittyFailedResult(error))
      });
    });
  }
  listThreads(request) {
    const parameters = {};
    if (request.filter?.includeMainThread === false) {
      parameters.includeMainThread = false;
    }
    if (request.filter?.standalone === true) {
      parameters.standalone = true;
    }
    return new Promise(resolve => {
      ChatKittyPaginator.createInstance({
        stompX: this.stompX,
        relay: request.channel._relays.threads,
        contentName: 'threads',
        parameters
      }).then(paginator => resolve(new ListThreadsSucceededResult(paginator))).catch(error => resolve(new ChatKittyFailedResult(error)));
    });
  }
  listThreadChannel(request) {
    return new Promise(resolve => {
      this.stompX.relayResource({
        destination: request.thread._relays.channel,
        onSuccess: resource => {
          resolve(new RetrieveThreadChannelSucceededResult(resource));
        },
        onError: error => {
          resolve(new ChatKittyFailedResult(error));
        }
      });
    });
  }
  listThreadMessage(request) {
    return new Promise(resolve => {
      this.stompX.relayResource({
        destination: request.thread._relays.message,
        onSuccess: resource => {
          resolve(new RetrieveThreadMessageSucceededResult(resource));
        },
        onError: error => {
          resolve(new ChatKittyFailedResult(error));
        }
      });
    });
  }
  readThread(request) {
    const currentUser = this.currentUser;
    if (!currentUser) {
      throw new NoActiveSessionError();
    }
    return new Promise(resolve => {
      this.stompX.sendAction({
        destination: request.thread._actions.read,
        body: {},
        onSent: () => resolve(new ReadThreadSucceededResult(request.thread)),
        onError: error => resolve(new ChatKittyFailedResult(error))
      });
    });
  }
  reactToMessage(request) {
    return new Promise(resolve => {
      this.stompX.sendAction({
        destination: request.message._actions.react,
        body: {
          emoji: request.emoji
        },
        onSuccess: reaction => resolve(new ReactedToMessageResult(reaction)),
        onError: error => resolve(new ChatKittyFailedResult(error))
      });
    });
  }
  listReactions(request) {
    return new Promise(resolve => {
      ChatKittyPaginator.createInstance({
        stompX: this.stompX,
        relay: request.message._relays.reactions,
        contentName: 'reactions'
      }).then(paginator => resolve(new ListReactionsSucceededResult(paginator))).catch(error => resolve(new ChatKittyFailedResult(error)));
    });
  }
  removeReaction(request) {
    return new Promise(resolve => {
      this.stompX.sendAction({
        destination: request.message._actions.removeReaction,
        body: {
          emoji: request.emoji
        },
        onSuccess: reaction => resolve(new RemovedReactionResult(reaction)),
        onError: error => resolve(new ChatKittyFailedResult(error))
      });
    });
  }
  deleteMessage(request) {
    return new Promise(resolve => {
      this.stompX.sendAction({
        destination: request.message._actions.delete,
        body: {},
        onSuccess: resource => resolve(new DeleteMessageSucceededResult(resource)),
        onError: error => resolve(new ChatKittyFailedResult(error))
      });
    });
  }
  sendKeystrokes(request) {
    const currentUser = this.currentUser;
    if (!currentUser) {
      throw new NoActiveSessionError();
    }
    this.keyStrokesSubject.next(request);
  }
  onNotificationReceived(onNextOrObserver) {
    const currentUser = this.currentUser;
    if (!currentUser) {
      throw new NoActiveSessionError();
    }
    const unsubscribe = this.stompX.listenForEvent({
      topic: currentUser._topics.notifications,
      event: 'user.notification.created',
      onSuccess: notification => {
        if (typeof onNextOrObserver === 'function') {
          onNextOrObserver(notification);
        } else {
          onNextOrObserver.onNext(notification);
        }
      }
    });
    return () => unsubscribe;
  }
  onChannelJoined(onNextOrObserver) {
    const currentUser = this.currentUser;
    if (!currentUser) {
      throw new NoActiveSessionError();
    }
    const unsubscribe = this.stompX.listenForEvent({
      topic: currentUser._topics.channels,
      event: 'user.channel.joined',
      onSuccess: channel => {
        if (typeof onNextOrObserver === 'function') {
          onNextOrObserver(channel);
        } else {
          onNextOrObserver.onNext(channel);
        }
      }
    });
    return () => unsubscribe;
  }
  onChannelHidden(onNextOrObserver) {
    const currentUser = this.currentUser;
    if (!currentUser) {
      throw new NoActiveSessionError();
    }
    const unsubscribe = this.stompX.listenForEvent({
      topic: currentUser._topics.channels,
      event: 'user.channel.hidden',
      onSuccess: channel => {
        if (typeof onNextOrObserver === 'function') {
          onNextOrObserver(channel);
        } else {
          onNextOrObserver.onNext(channel);
        }
      }
    });
    return () => unsubscribe;
  }
  onChannelUnhidden(onNextOrObserver) {
    const currentUser = this.currentUser;
    if (!currentUser) {
      throw new NoActiveSessionError();
    }
    const unsubscribe = this.stompX.listenForEvent({
      topic: currentUser._topics.channels,
      event: 'user.channel.unhidden',
      onSuccess: channel => {
        if (typeof onNextOrObserver === 'function') {
          onNextOrObserver(channel);
        } else {
          onNextOrObserver.onNext(channel);
        }
      }
    });
    return () => unsubscribe;
  }
  onChannelLeft(onNextOrObserver) {
    const currentUser = this.currentUser;
    if (!currentUser) {
      throw new NoActiveSessionError();
    }
    const unsubscribe = this.stompX.listenForEvent({
      topic: currentUser._topics.channels,
      event: 'user.channel.left',
      onSuccess: channel => {
        if (typeof onNextOrObserver === 'function') {
          onNextOrObserver(channel);
        } else {
          onNextOrObserver.onNext(channel);
        }
      }
    });
    return () => unsubscribe;
  }
  onChannelUpdated(onNextOrObserver) {
    const currentUser = this.currentUser;
    if (!currentUser) {
      throw new NoActiveSessionError();
    }
    const unsubscribe = this.stompX.listenForEvent({
      topic: currentUser._topics.channels,
      event: 'user.channel.updated',
      onSuccess: channel => {
        if (typeof onNextOrObserver === 'function') {
          onNextOrObserver(channel);
        } else {
          onNextOrObserver.onNext(channel);
        }
      }
    });
    return () => unsubscribe;
  }
  listChannelMembers(request) {
    const currentUser = this.currentUser;
    if (!currentUser) {
      throw new NoActiveSessionError();
    }
    return new Promise(resolve => {
      ChatKittyPaginator.createInstance({
        stompX: this.stompX,
        relay: request.channel._relays.members,
        contentName: 'users',
        parameters: _objectSpread({}, request.filter)
      }).then(paginator => resolve(new ListUsersSucceededResult(paginator))).catch(error => resolve(new ChatKittyFailedResult(error)));
    });
  }
  listReadReceipts(request) {
    const currentUser = this.currentUser;
    if (!currentUser) {
      throw new NoActiveSessionError();
    }
    return new Promise(resolve => {
      ChatKittyPaginator.createInstance({
        stompX: this.stompX,
        relay: request.message._relays.readReceipts,
        contentName: 'receipts'
      }).then(paginator => resolve(new ListReadReceiptsSucceededResult(paginator))).catch(error => resolve(new ChatKittyFailedResult(error)));
    });
  }
  listUsers(request) {
    const currentUser = this.currentUser;
    if (!currentUser) {
      throw new NoActiveSessionError();
    }
    return new Promise(resolve => {
      let parameters = undefined;
      if (isListUsersRequest(request)) {
        parameters = _objectSpread({}, request.filter);
      }
      ChatKittyPaginator.createInstance({
        stompX: this.stompX,
        relay: currentUser._relays.contacts,
        contentName: 'users',
        parameters: parameters
      }).then(paginator => resolve(new ListUsersSucceededResult(paginator))).catch(error => resolve(new ChatKittyFailedResult(error)));
    });
  }
  listUsersCount(request) {
    const currentUser = this.currentUser;
    if (!currentUser) {
      throw new NoActiveSessionError();
    }
    return new Promise(resolve => {
      let parameters = undefined;
      if (isListUsersRequest(request)) {
        parameters = _objectSpread({}, request.filter);
      }
      this.stompX.relayResource({
        destination: currentUser._relays.contactsCount,
        parameters: parameters,
        onSuccess: resource => {
          resolve(new CountSucceededResult(resource.count));
        },
        onError: error => resolve(new ChatKittyFailedResult(error))
      });
    });
  }
  onUserPresenceChanged(onNextOrObserver) {
    const currentUser = this.currentUser;
    if (!currentUser) {
      throw new NoActiveSessionError();
    }
    const unsubscribe = this.stompX.listenForEvent({
      topic: currentUser._topics.contacts,
      event: 'contact.presence.changed',
      onSuccess: user => {
        if (typeof onNextOrObserver === 'function') {
          onNextOrObserver(user);
        } else {
          onNextOrObserver.onNext(user);
        }
      }
    });
    return () => unsubscribe;
  }
  inviteUser(request) {
    const destination = request.channel._actions.invite;
    if (!destination) {
      throw new ChannelNotInvitableError(request.channel);
    }
    return new Promise(resolve => {
      this.stompX.sendAction({
        destination: destination,
        body: {
          user: request.user
        },
        onSuccess: resource => {
          resolve(new InvitedUserResult(resource));
        },
        onError: error => resolve(new ChatKittyFailedResult(error))
      });
    });
  }
  onParticipantStartedTyping(onNextOrObserver) {
    const currentUser = this.currentUser;
    if (!currentUser) {
      throw new NoActiveSessionError();
    }
    const unsubscribe = this.stompX.listenForEvent({
      topic: currentUser._topics.participants,
      event: 'participant.typing.started',
      onSuccess: participant => {
        if (typeof onNextOrObserver === 'function') {
          onNextOrObserver(participant);
        } else {
          onNextOrObserver.onNext(participant);
        }
      }
    });
    return () => unsubscribe;
  }
  onParticipantStoppedTyping(onNextOrObserver) {
    const currentUser = this.currentUser;
    if (!currentUser) {
      throw new NoActiveSessionError();
    }
    const unsubscribe = this.stompX.listenForEvent({
      topic: currentUser._topics.participants,
      event: 'participant.typing.stopped',
      onSuccess: participant => {
        if (typeof onNextOrObserver === 'function') {
          onNextOrObserver(participant);
        } else {
          onNextOrObserver.onNext(participant);
        }
      }
    });
    return () => unsubscribe;
  }
  retrieveUser(param) {
    return new Promise(resolve => {
      this.stompX.relayResource({
        destination: ChatKitty.userRelay(param),
        onSuccess: user => {
          resolve(new ListUserSucceededResult(user));
        }
      });
    });
  }
  checkUserIsChannelMember(request) {
    const currentUser = this.currentUser;
    if (!currentUser) {
      throw new NoActiveSessionError();
    }
    return new Promise(resolve => {
      this.stompX.relayResource({
        destination: request.user._relays.channelMember,
        parameters: {
          channelId: request.channel.id
        },
        onSuccess: resource => {
          resolve(new CheckUserIsChannelMemberSucceededResult(resource.exists));
        },
        onError: error => {
          resolve(new ChatKittyFailedResult(error));
        }
      });
    });
  }
  blockUser(request) {
    return new Promise(resolve => {
      this.stompX.sendAction({
        destination: `/application/v1/users/${request.user.id}.block`,
        body: {},
        onSuccess: resource => {
          resolve(new BlockUserSucceededResult(resource));
        },
        onError: error => resolve(new ChatKittyFailedResult(error))
      });
    });
  }
  listUserBlockedRecords() {
    const currentUser = this.currentUser;
    if (!currentUser) {
      throw new NoActiveSessionError();
    }
    return new Promise(resolve => {
      ChatKittyPaginator.createInstance({
        stompX: this.stompX,
        relay: currentUser._relays.userBlockedRecords,
        contentName: 'items'
      }).then(paginator => resolve(new ListUserBlockedRecordsSucceededResult(paginator))).catch(error => resolve(new ChatKittyFailedResult(error)));
    });
  }
  deleteUserBlockedRecord(request) {
    return new Promise(resolve => {
      this.stompX.sendAction({
        destination: request.item._actions.delete,
        body: {},
        onSuccess: resource => resolve(new DeleteUserBlockedRecordSucceededResult(resource)),
        onError: error => resolve(new ChatKittyFailedResult(error))
      });
    });
  }
}
class MessageMapper {
  readFileGrant;
  constructor(grant) {
    this.readFileGrant = grant;
  }
  map(message) {
    if (isFileMessage(message)) {
      return _objectSpread(_objectSpread({}, message), {}, {
        file: _objectSpread(_objectSpread({}, message.file), {}, {
          url: message.file.url + `?grant=${this.readFileGrant}`
        })
      });
    } else {
      return _objectSpread({}, message);
    }
  }
}
function isListChannelsRequest(param) {
  const request = param;
  return request?.filter !== undefined;
}
function isListUsersRequest(param) {
  const request = param;
  return request?.filter !== undefined;
}
function isListChannelsUnreadRequest(param) {
  const request = param;
  return request?.filter !== undefined;
}
function isCountUnreadMessagesRequest(param) {
  const request = param;
  return request?.channel !== undefined;
}
function isSendChannelTextMessageRequest(request) {
  return request.body !== undefined;
}
function isSendChannelFileMessageRequest(request) {
  return request.file !== undefined;
}
function isListUsersMessagesRequest(request) {
  return request.channel === undefined && request.message === undefined;
}
function isListChannelMessagesRequest(request) {
  return request.channel !== undefined;
}
function isListMessageRepliesRequest(request) {
  return request.message !== undefined;
}
function isCreateChatKittyExternalFileProperties(result) {
  return result.url !== undefined && result.name !== undefined && result.size !== undefined;
}
export { AddedChannelModeratorResult, BlockUserSucceededResult, CannotAddModeratorToChannelError, ChannelNotInvitableError, ChannelNotPubliclyJoinableError, ChatKitty, ChatKittyError, ChatKittyFailedResult, ChatKittyPaginator, ChatKittySucceededResult, ChatKittyUploadResult, CheckChannelUnreadSucceededResult, CheckUserIsChannelMemberSucceededResult, ClearChannelHistorySucceededResult, CountSucceededResult, CreatedChannelResult, CreatedThreadResult, DeleteMessageSucceededResult, DeleteUserBlockedRecordSucceededResult, DeletedChannelResult, EditedMessageSucceededResult, HideChannelSucceededResult, InvitedUserResult, JoinedChannelResult, LeftChannelResult, ListChannelsSucceededResult, ListMessagesSucceededResult, ListReactionsSucceededResult, ListReadReceiptsSucceededResult, ListThreadsSucceededResult, ListUserBlockedRecordsSucceededResult, ListUserSucceededResult, ListUsersSucceededResult, MessageNotAReplyError, MutedChannelResult, NoActiveSessionError, NotAChannelMemberError, PageOutOfBoundsError, ReactedToMessageResult, ReadChannelSucceededResult, ReadMessageSucceededResult, ReadThreadSucceededResult, RemovedReactionResult, RetrieveChannelContextSucceededResult, RetrieveChannelSucceededResult, RetrieveCurrentUserSuccessfulResult, RetrieveLastReadMessageSucceededResult, RetrieveMessageChannelSucceededResult, RetrieveMessageParentSucceededResult, RetrieveThreadChannelSucceededResult, RetrieveThreadMessageSucceededResult, SentFileMessageResult, SentTextMessageResult, SessionActiveError, StartedChatSessionResult, StartedSessionResult, TriggeredEventResult, UnmutedChannelResult, UnreadMessageSucceededResult, UpdatedChannelResult, UpdatedCurrentUserDisplayPictureResult, UpdatedCurrentUserResult, UpdatedMessagePropertiesSucceededResult, ChatKitty as default, isDirectChannel, isFileMessage, isPrivateChannel, isPublicChannel, isSystemMessage, isSystemSentMessageNotification, isTextMessage, isUserMentionedChannelNotification, isUserMentionedNotification, isUserMessage, isUserRepliedToMessageNotification, isUserSentMessageNotification, sentFileMessage, sentTextMessage };
//# sourceMappingURL=index.js.map
