import StompX, { StompXError, StompXPageMetadata } from './stompx';
import { ChatKittyError } from './error';
export declare class ChatKittyPaginator<I> {
    items: I[];
    page: StompXPageMetadata;
    private stompX;
    private contentName;
    private prevRelay?;
    private nextRelay?;
    private parameters?;
    private mapper?;
    private asyncMapper?;
    /** @internal */
    static createInstance<I>(request: CreatePaginatorRequest<I>): Promise<ChatKittyPaginator<I>>;
    private constructor();
    get hasPrevPage(): boolean;
    get hasNextPage(): boolean;
    prevPage(): Promise<ChatKittyPaginator<I>>;
    nextPage(): Promise<ChatKittyPaginator<I>>;
    private getPage;
}
export declare class CreatePaginatorRequest<I> {
    stompX: StompX;
    relay: string;
    contentName: string;
    parameters?: Record<string, unknown>;
    size?: number;
    sort?: string;
    mapper?: (item: I) => I;
    asyncMapper?: (item: I) => Promise<I>;
    onError?: (error: StompXError) => void;
}
export declare class PageOutOfBoundsError extends ChatKittyError {
    constructor();
}
//# sourceMappingURL=pagination.d.ts.map