import { Emoji } from './emoji';
import { Message } from './message';
import { ChatKittyPaginator } from './pagination';
import { ChatKittyFailedResult, ChatKittySucceededResult } from './result';
import { User } from './user';
export declare class Reaction {
    emoji: Emoji;
    user: User;
    createdTime: string;
    /** @internal */
    _relays: ReactionRelays;
}
declare class ReactionRelays {
    message: string;
}
export declare class ReactionSummary {
    emoji: Emoji;
    users: User[];
    count: number;
}
export declare class ReactToMessageRequest {
    message: Message;
    emoji: string;
}
export type ReactToMessageResult = ReactedToMessageResult | ChatKittyFailedResult;
export declare class ReactedToMessageResult extends ChatKittySucceededResult {
    reaction: Reaction;
    constructor(reaction: Reaction);
}
export declare class ListReactionsRequest {
    message: Message;
}
export type ListReactionsResult = ListReactionsSucceededResult | ChatKittyFailedResult;
export declare class ListReactionsSucceededResult extends ChatKittySucceededResult {
    paginator: ChatKittyPaginator<Reaction>;
    constructor(paginator: ChatKittyPaginator<Reaction>);
}
export declare class RemoveReactionRequest {
    message: Message;
    emoji: string;
}
export type RemoveReactionResult = RemovedReactionResult | ChatKittyFailedResult;
export declare class RemovedReactionResult extends ChatKittySucceededResult {
    reaction: Reaction;
    constructor(reaction: Reaction);
}
export {};
//# sourceMappingURL=reaction.d.ts.map